#pragma rtGlobals=1		// Use modern global access method.

// ** MIT Rocket Team data analysis package **
//		written by Tom Nugent
// Re-written starting June 4, 2003
// And boy is it taking a long time to fix...

Function GrabRocketData(ctrlName) : ButtonControl
	String ctrlName
	// define local variables
	String timeRef
	Variable i, j, fileChosenYN
	// define global variables
	String/G stampTime, testNumber, testName, exptInfo=""
	String tempSpunYN="Yes", tempPrintYN="Yes", tempWhichLiquid="LN2"//, analyzeYesNo="Yes"
	String/G spunYesNo, printYesNo, whichLiquid

	// *********************************************
	//		Ask the user about whether the tach spun up.
	//Prompt tempSpunYN, "Was the engine spun? ", popup, "Yes;No"
	//Prompt tempPrintYN, "Do you want to display layouts for immediate printing? ", popup, "Yes;No"
	// Prompt analyzeYesNo, "Do you want to do all data analysis now (or later)? ", popup, "Yes;No"

//	******** Uncomment the following once I add in data differences  (7/7/01) ********
//	Prompt tempWhichLiquid, "Which liquid was pumped?", popup, "LN2;LOX"
//	DoPrompt "Answer the questions", tempWhichLiquid//, tempSpunYN, tempPrintYN , analyzeYesNo
	
	spunYesNo = tempSpunYN
	printYesNo = tempPrintYN
	whichLiquid = tempWhichLiquid

	// ***********************************
	// Read in the data file.
	fileChosenYN = ReadInRocketData("")

	// Grab the time and a sort of test number from the data, if the file was opened
	if (fileChosenYN == 0)
		timeRef = exptInfo
		
		stampTime = RemoveListItem(0, timeRef, "\t")
		print "The start time was " + stampTime
	
		Variable stringLength=0
		stringLength = strlen(testName)
		
		testNumber = testName[0,(stringLength-10)]
	endif
End

Function ReadInRocketData(fileName)
	String fileName			// file name, partial path and file name, or full path or "" for dialog.
	Variable err
	String/G exptInfo=""
	SVAR testName = root:testName
	Variable refNum
	String message = "Select the rocket test data file."
	Open/R/Z=2/M=message/T="????" refNum as fileName
	
	// Save outputs from Open in a safe place.
	err = V_Flag
	
	// check to see if the user cancelled the file open
	if (err == -1)
		print "User cancelled."
		return -1			// User cancelled.
	endif
	
	String fullPath = S_fileName

	SetDataFolder root:	// just to be safe
	
	// if a file was opened, load the data and close the file
	if (err == 0)
		Printf "Loading example data from \"%s\"\r", fullPath
	
		FReadLine refNum, exptInfo
		FStatus refNum
		testName = S_fileName 
		
		Print exptInfo
	
		LoadWave/W/A/D/G/O fullPath
	
		Close refNum		// Close the file.
		return 0
	endif
End

Function PopMenuProc(ctrlName,popNum,popStr) : PopupMenuControl
	String ctrlName
	Variable popNum
	String popStr
	String/G currentPlottingGraph="none"
	// *** Change this string variable (or something elsewhere?) so that the first item in the pop-up list
	//*** can be plotted without selecting anything from the pop-up list.
	
//	SVAR currentPlottingGraph
	currentPlottingGraph = popStr+"()"
End

Function PlotTheGraph(ctrlName) : ButtonControl
	String ctrlName
	String/G currentPlottingGraph
//	SVAR currentPlottingGraph
	Execute currentPlottingGraph
End

Function SetMarkerSkip (ctrlName,varNum,varStr,varName) : SetVariableControl
	String ctrlName
	Variable varNum	// value of variable as number
	String varStr		// value of variable as string
	String varName	// name of variable
	NVAR graphMarkerSkip = root:TheGlobals:graphMarkerSkip
	graphMarkerSkip = varNum
	
	String localWindowList, tempItem
	Variable n,i
	localWindowList = WinList("*",";","WIN:7")
	n  = ItemsInList(localWindowList,";")
	for (i=0; i<= n-1; i+=1)
		tempItem = StringFromList(i,localWindowList,";")
		ModifyGraph/W=$tempItem mskip=graphMarkerSkip
	endfor
End



Function PreProcessData(ctrlName) : ButtonControl
	String ctrlName
	String tempFileName=""
	Variable tempRefNum

//	Eventually, this section will read in the power curve parameters from a data file, instead of having them
// 	hard-coded in this .ipf file.
	Open/R/Z=0/P=Igor tempRefNum as ":RocketTeamParameters:PowerCurveParameters.tab"
	String fullPath = S_fileName
	LoadWave/W/A/J/B="C=1,F=-2; C=5,F=0;"/D/O fullPath
	print "The parameter file was at " + fullPath
	Close tempRefNum

	print "PowerCurve file reading is not functional yet"

//	This section is to help set the y=0 point for those data sensors which tend to drift a bit and not be really
// 	zeroed when we take the data.  Amps is the worst of the bunch and the most important.
	Duplicate/O Battery_Amps Battery_Amps_Backup
	Duplicate/O LOX_Flow LOX_Flow_Backup
	Duplicate/O Kero_Flow Kero_Flow_Backup
	
	ReZeroDataFromGraph("Battery_Amps")

//	Implement the following two after I've made the Function ReZero independent of data wave & graph name:	
//	ReZeroDataFromGraph("LOX_Flow")
//	ReZeroDataFromGraph("Kero_Flow")

	//	Here's how we'll display a graph and have the user select the region to zero the graph on.
//	Display /W=(5,42,400,250) LOX_Flow
//	Cursor/P A, LOX_Flow, leftx(LOX_Flow)
//	ShowInfo
//	ControlBar 22
//		
//		Window testGraph12() : Graph
//			PauseUpdate; Silent 1		// building window...
//			Display /W=(171,193,893,719) Kero_Flow
//			AppendToGraph/R Tach
//			ModifyGraph rgb(Kero_Flow)=(1,4,52428)
//			SetAxis/A/N=1 left
//			Cursor/P A Kero_Flow 690;Cursor/P/A=0 B Kero_Flow 10866
//			ShowInfo
//			ControlBar 60
//			ValDisplay valdisp0,pos={6,4},size={80,14},title="point1"
//			ValDisplay valdisp0,limits={0,50000,0},barmisc={0,1000},value= #"50"
//			SetVariable setvar0,pos={120,1},size={200,15},title="Left Csr"
//			SetVariable setvar0,limits={-Inf,Inf,1},value= K0
//			WaveStats Kero_Flow
//			Slider slidevar0,pos={340,3},size={300,56},vert= 0
//			Slider slidevar0,limits={0,V_npnts-1,0},value= 100, proc=mySliderProc
//		EndMacro
//		
//		Function MySliderProc(name, value, event)
//			String name	// name of this slider control
//			Variable value	// value of slider
//			Variable event	// bit field: bit 0: value set; 1: mouse down, 
//						//   2: mouse up, 3: mouse moved
//			Cursor/W=testGraph12 A, Kero_Flow, value		
//			return 0	// other return values reserved
//		End
End

Function ReZeroDataFromGraph(dataName)
	// This Function will try to guess where the pre-test data section is, ask the user to confirm the range selected,
	// and then use that range to set the y=0 point for the data (and adjust all data accordingly).
	String dataName
	String/G data2ReZero = dataName
	String graphName = dataName + "_ReZero_Graph"
	PauseUpdate; Silent 1		// building window...
	Display /W=(50,50,610,480) $dataName as graphName
	AppendToGraph/R Tach
	ModifyGraph mode=4
	ModifyGraph marker($dataName)=8
	ModifyGraph rgb($dataName)=(1,12815,52428)
	ModifyGraph msize=2.5
	ModifyGraph mskip=70
	ModifyGraph grid(left)=1,grid(bottom)=1
	ModifyGraph gridStyle(left)=3,gridStyle(bottom)=3
	Label bottom "Time"
	Label right "Tach (\\u rpm)"

//	SetAxis/A/N=12 left	
//	SetAxis/Z bottom plotBegin,plotEnd
//	SetAxis right -100,topSpeed
	Legend/N=theLegend/J/M/A=MB/X=-30.0/Y=1.0/E "\\Z10\\s("+dataName+") " + dataName + " \r\\s(Tach) Tach"
	
	ControlBar 25
	Button continueBtn,pos={5,1},size={100,20},proc=ReZero,title="Continue"
	ShowInfo
	Cursor/P A, $dataName, leftx($dataName)
	Cursor/P B, $dataName, pnt2x($dataName,numpnts($dataName)/2)
End

Function ReZero(ctrlName) : ButtonControl
	// This Function does the actual re-zeroing of data.  It's called from the Function "ReZeroDataFromGraph"
	String ctrlName
	SVAR data2ReZero
	WAVE Battery_Amps = root:Battery_Amps
//	WAVE data2ReZero
	WaveStats/R=(xcsr(A),xcsr(B)) Battery_Amps
	Variable offset = V_avg
	Execute "print Battery_Amps[5]"
//	Execute "Battery_Amps -= offset"
	Battery_Amps -= offset
	Execute "print Battery_Amps[5]"
	
	String theWindow
	theWindow = StringFromList(0,WinList("*",";","WIN:"),";")
	print theWindow
	DoWindow/K $theWindow

End


Function RedoPowerCalcs(ctrlName) : ButtonControl
	String ctrlName
	WAVE TimeW = root:TimeW
	WAVE Battery_Voltage = root:Battery_Voltage
	WAVE Battery_Amps = root:Battery_Amps
	WAVE Tach = root:Tach
	
	WAVE tachAcceleration = root:tachAcceleration

	// **********************************
	// Engine Power
	// **********************************
	Duplicate/O Battery_Voltage Power_MotorShaft
	SetScale d 0,0,"Watts", Power_MotorShaft
	Variable efficiency_plus = 0.8, efficiency_minus = 0.6
	Variable i
	NVAR numpoints
	
	// efficiency_plus is small for tach near 0 and larger for high tach

	for (i=0; i<=numpoints-1; i+=1)
		if (Battery_Amps[i] > 0)
			Power_MotorShaft[i] = Battery_Voltage[i] * Battery_Amps[i] * efficiency_plus
		else
			Power_MotorShaft[i] = Battery_Voltage[i] * Battery_Amps[i] / efficiency_minus
		endif
	endfor
	
	Duplicate/O Battery_Amps Power_Inertial
	SetScale d 0,0,"Watts", Power_Inertial
	Power_Inertial = Tach * tachAcceleration * (1.7*10^-5)// 1.7 is average value; #2035 mom.inert. was (1.64*10^-5) ;; OLD:(-2.8 * 10^-5)
		
	Duplicate/O Battery_Amps Power_SteadyState
	SetScale d 0,0,"Watts", Power_SteadyState
	// OLD: Power_SteadyState = -(-(4*10^-16)*Tach^4 + (7*10^-11)*Tach^3 - (5*10^-7)*Tach^2 + 0.007*Tach - 5.78)
	// This is the steady state power curve derived from the spin-down test (data from test #2035)
	//Power_SteadyState = (-(2.099*10^-15)*Tach^4 + (1.613*10^-10)*Tach^3 - (2.218*10^-6)*Tach^2 + 0.0135*Tach - 5.269)

	// (7/16/01) we use the power curve derived from tests #2049, 2050, 2056, and 2059
	// Power_SteadyState = -0.000164*Tach + 5.459E-7*Tach^2 + 9.917E-12*Tach^3 + 3.980E-17*Tach^4
	// (7/20/01) NH spin-down test, #2097
	Power_SteadyState = 0.00242*Tach + 1.105e-7*Tach^2 + 2.011e-11*Tach^3 - 2.360e-16*Tach^4


	Duplicate/O Battery_Amps Power_Anomalous
	SetScale d 0,0,"Watts", Power_Anomalous
	// OLD: Power_Anomalous = -Power_MotorShaft - Power_Inertial
	// This is actually power measured - power expected --- it should be zero, except for pumping, jets, etc.
	Power_Anomalous = Power_SteadyState + Power_Inertial - Power_MotorShaft

	Duplicate/O Power_Anomalous PowerAnomalous_smooth
	Duplicate/O Power_Inertial PowerInertial_smooth
	Smooth 9, PowerAnomalous_smooth
	Smooth 9, PowerInertial_smooth
End

//Window ReZeroPanel() : Panel
//	PauseUpdate; Silent 1		// building window...
//	NewPanel /W=(100,90,360,212)
//	ShowTools
//	SetDrawLayer UserBack
//	SetDrawEnv fname= "default"
//	DrawText 5,20,"Select which variables to re-zero:"
//	CheckBox check0,pos={28,30},size={44,14},title="Amps",value= 1
//	CheckBox check1,pos={28,55},size={60,14},title="LOX flow",value= 0
//	CheckBox check2,pos={28,81},size={65,14},title="Kero flow",value= 1
//	Button continueBtn,pos={149,51},size={70,20},title="Continue"
//	
//	// ControlInfo checkboxName
////	if (V_flag ==2)
////		if (V_Value == 1)
////			// it's checked, let's do something
////		endif
////	endif
//		
//EndMacro


Function AddTimeLine()
	String commandLine
	Variable k=0
	WAVE/T eventText = root:eventText
	WAVE/T eventLine = root:eventLine
	NVAR eventLength
	SetDrawLayer UserFront
	do
		if (k>0)
			SetDrawEnv xcoord= bottom, ycoord = prel, fsize= 8, textxjust= 1,textrot=90
			commandLine = "DrawText " + eventText[k]
			Execute commandLine
			SetDrawEnv xcoord= bottom, ycoord= prel, linepat= 3, linethick= 0.75, dash= 3
			commandLine = "DrawLine " + eventLine[k]
			Execute commandLine
		endif
		k += 1
	while (k<eventLength)
End

Function CloseAllGraphsAndLayouts(ctrlName) : ButtonControl
	String ctrlName
	String localWindowList, tempItem
	Variable n,i
	localWindowList = WinList("*",";","WIN:7")
//	print "List is " + localWindowList
	n  = ItemsInList(localWindowList,";")
	for (i=0; i<= n-1; i+=1)
		tempItem = StringFromList(i,localWindowList,";")
		DoWindow/K $tempItem
	endfor
End


// Break next function into different functions for Turbopump, Chamber, FullEngine, etc.
Function PrintCoreGraphs(ctrlName) : ButtonControl
	String ctrlName
	SVAR spunYesNo, printYesNo, testNumber

	// ***********************************
	// Execute graphing macros
	// ***********************************
	Execute "eventsTable()"
	Execute "BatteryHysteresis()"
	Execute "BatteryVolts()"
	Execute "BatteryAmps()"
	Execute "PowerCurves()"
	Execute "ChamberPressure()"
	Execute "allPowerCurves()"
	// Do the layouts
	Execute "BatteryHysteresis_layout()"
	Execute "PowerCurves_layout()"
	Execute "ChamberPressure_layout()"
	Execute "BatteryVolts_layout()"
	Execute "BatteryAmps_layout()"
	Execute "allPowerCurves_layout()"
	Execute "extraData_layout()"
	
	// Print
	PrintLayout ChamberPressure_layout
	PrintLayout PowerCurves_layout
	PrintLayout BatteryVolts_layout
	PrintLayout BatteryAmps_layout
	PrintLayout BatteryHysteresis_layout
	PrintLayout allPowerCurves_layout
	PrintLayout extraData_layout
	
	// Now close all of those layout windows
	DoWindow/K ChamberPressure_layout
	DoWindow/K PowerCurves_layout
	DoWindow/K BatteryVolts_layout
	DoWindow/K BatteryAmps_layout
	DoWindow/K BatteryHysteresis_layout
	DoWindow/K extraData_layout
	DoWindow/K allPowerCurves_layout
End

Function PrintAllGraphs(ctrlName) : ButtonControl
	String ctrlName
	SVAR spunYesNo, printYesNo, testNumber

	String localWindowList, localGraphList, localLayoutList, graphList, layoutList, tempItem
	Variable n,i

		// close any open graphs or layouts
	localWindowList = WinList("*",";","WIN:5")
	n  = ItemsInList(localWindowList,";")
	for (i=0; i<= n-1; i+=1)
		tempItem = StringFromList(i,localWindowList,";")
		DoWindow/K tempItem
	endfor

		// open all of the graphs
	graphList = MacroList("*",";","KIND:4,SUBTYPE:Graph")
	n = ItemsInList (graphList, ";")
	localGraphList = ""
	for (i=0; i<= n-1; i+=1)
		tempItem = StringFromList(i,graphList,";") + "()"
		Execute tempItem
		//localGraphList = AddListItem(tempItem, localGraphList, ";")
	endfor
	//print localGraphList
	//Execute localGraphList

//************************************************************************
// NOTE:
//		Combine the the following two sections so that the opening, printing, and closing of
//		the layouts happens in a single loop.  I.e, it will open a layout, print it, close it, and move
//		on to the next layout.  (7/7/01)
//************************************************************************
	
		// open all of the layouts
	Execute "eventsTable()"
	layoutList = MacroList("*",";","KIND:4,SUBTYPE:Layout")
	print layoutList
	n = ItemsInList (layoutList, ";")
	localLayoutList = ""
	for (i=0; i<= n-1; i+=1)
		tempItem = StringFromList(i,layoutList,";") + "()"
		Execute tempItem
		//localLayoutList = AddListItem(tempItem, localLayoutList, ";")
	endfor
	//print localLayoutList
	//Execute localLayoutList
	n = 0
	tempItem = ""

		// Now close all of those layout windows & graphs
	localWindowList = WinList("*",";","WIN:4")
	n  = ItemsInList(localWindowList,";")
	for (i=0; i<= n-1; i+=1)
		tempItem = StringFromList(i,localWindowList,";")
		PrintLayout $tempItem
		DoWindow/K $tempItem
	endfor

	localWindowList = WinList("*",";","WIN:7")
	n  = ItemsInList(localWindowList,";")
	for (i=0; i<= n-1; i+=1)
		tempItem = StringFromList(i,localWindowList,";")
		DoWindow/K $tempItem
	endfor

	DoWindow/K eventsTable
End

Function timeScale(ctrlName) : ButtonControl
	String ctrlName
	NVAR plotBegin, plotEnd
	SetAxis/Z bottom plotBegin,plotEnd
End

Function closeWindow(ctrlName) : ButtonControl
	String ctrlName
	String theWindow
	theWindow = StringFromList(0,WinList("*",";","WIN:"),";")
	print theWindow
	DoWindow/K $theWindow
End




Window eventsTable() : Table
	PauseUpdate; Silent 1		// building window...
	Edit/W=(571,104,818,461) table_eventTimes,table_events
	ModifyTable width(Point)=0,width(table_eventTimes)=90
EndMacro


Window extraData_layout() : Layout
	PauseUpdate; Silent 1		// building window...
	Layout/P=Landscape/C=1/W=(5,42,480,423) as "Extra data"
	TextBox/N=NumRevs_text/M/A=LC/X=43.82/Y=25.82 "\\Z14 Number of Revolutions = \\f01" + num2str(totalRevs)
	TextBox/N=speed_text/M/A=LC/X=43.82/Y=0.0 "\\Z14 Max rotation speed = \\f01" + num2str(maxSpeed) + " rpm"
	TextBox/N=TestInfo/D={1,3,-1}/S=3/M/A=MT/X=20.05/Y=1.45 "\\JC\\Z12"+testNumber+"\r "+stampTime+" \\f01 Extra test information "
	Append eventsTable(92,121,266,429)/O=2
	ModifyLayout mag=0.5, units=1
EndMacro


Window ChamberPressure_layout() : Layout
	PauseUpdate; Silent 1		// building window...
	Layout/P=Landscape/C=1/W=(4.8,42.2,505.8,387.8) ChamberPressure(72.6,72.6,719.4,539.4)/O=1
EndMacro

Window PowerCurves_layout() : Layout
	PauseUpdate; Silent 1		// building window...
	Layout/P=Landscape/C=1/W=(4.8,42.2,505.8,387.8) PowerCurves(72.6,72.6,719.4,539.4)/O=1
EndMacro

Window allPowerCurves_layout() : Layout
	PauseUpdate; Silent 1		// building window...
	Layout/P=Landscape/C=1/W=(4.8,42.2,505.8,387.8) allPowerCurves(72.6,72.6,719.4,539.4)/O=1
EndMacro

Window Power_Battery_multi_layout() : Layout
	PauseUpdate; Silent 1		// building window...
	Layout/P=Portrait/C=1/W=(5,45,410,490) Power_Battery_multiPlot(68,60,570,744)/O=1
EndMacro

Window LOX_Press_layout() : Layout
	PauseUpdate; Silent 1		// building window...
	Layout/P=Landscape/C=1/W=(4.8,42.2,505.8,387.8) LOX_Press(72.6,72.6,719.4,539.4)/O=1
EndMacro

Window Forces_all_layout() : Layout
	PauseUpdate; Silent 1		// building window...
	Layout/P=Landscape/C=1/W=(4.8,42.2,505.8,387.8) Forces_all(72.6,72.6,719.4,539.4)/O=1
EndMacro

Window Thermocouples_external_layout() : Layout
	PauseUpdate; Silent 1		// building window...
	Layout/P=Landscape/C=1/W=(4.8,42.2,505.8,387.8) Thermocouples_external(72.6,72.6,719.4,539.4)/O=1
EndMacro

Window Thermocouples_internal_layout() : Layout
	PauseUpdate; Silent 1		// building window...
	Layout/P=Landscape/C=1/W=(4.8,42.2,505.8,387.8) Thermocouples_internal(72.6,72.6,719.4,539.4)/O=1
EndMacro

Window BatteryHysteresis_layout() : Layout
	PauseUpdate; Silent 1		// building window...
	Layout/P=Landscape/C=1/W=(4.8,42.2,505.8,387.8) BatteryHysteresis(72.6,72.6,719.4,539.4)/O=1
EndMacro

Window BatteryVolts_layout() : Layout
	PauseUpdate; Silent 1		// building window...
	Layout/P=Landscape/C=1/W=(4.8,42.2,505.8,387.8) BatteryVolts(72.6,72.6,719.4,539.4)/O=1
EndMacro

Window BatteryAmps_layout() : Layout
	PauseUpdate; Silent 1		// building window...
	Layout/P=Landscape/C=1/W=(4.8,42.2,505.8,387.8) BatteryAmps(72.6,72.6,719.4,539.4)/O=1
EndMacro

Window LOXFlow_layout() : Layout
	PauseUpdate; Silent 1		// building window...
	Layout/P=Landscape/C=1/W=(4.8,42.2,505.8,387.8) LOXFlow(72.6,72.6,719.4,539.4)/O=1
EndMacro

Window LOXmassFlow_layout() : Layout
	PauseUpdate; Silent 1		// building window...
	Layout/P=Landscape/C=1/W=(4.8,42.2,505.8,387.8) LOXmassFlow_graph(72.6,72.6,719.4,539.4)/O=1
EndMacro

Window LOXlevel_layout() : Layout
	PauseUpdate; Silent 1		// building window...
	Layout/P=Landscape/C=1/W=(4.8,42.2,505.8,387.8) LOXlevel(72.6,72.6,719.4,539.4)/O=1
EndMacro

Window LOXdump_layout() : Layout
	PauseUpdate; Silent 1		// building window...
	Layout/P=Landscape/C=1/W=(4.8,42.2,505.8,387.8) LOXdump(72.6,72.6,719.4,539.4)/O=1
EndMacro

Window KeroFlow_layout() : Layout
	PauseUpdate; Silent 1		// building window...
	Layout/P=Landscape/C=1/W=(4.8,42.2,505.8,387.8) KeroFlow(72.6,72.6,719.4,539.4)/O=1
EndMacro

Window KeroDump_layout() : Layout
	PauseUpdate; Silent 1		// building window...
	Layout/P=Landscape/C=1/W=(4.8,42.2,505.8,387.8) KeroDump(72.6,72.6,719.4,539.4)/O=1
EndMacro

Window KeroWeight_layout() : Layout
	PauseUpdate; Silent 1		// building window...
	Layout/P=Landscape/C=1/W=(4.8,42.2,505.8,387.8) KeroWeight(72.6,72.6,719.4,539.4)/O=1
EndMacro

Proc RocketTeam_Style() : GraphStyle
	PauseUpdate; Silent 1		// modifying window...
	ModifyGraph/Z mode=4
	ModifyGraph/Z marker[1]=8,marker[2]=6,marker[3]=5,marker[4]=22,marker[5]=2,marker[6]=43
	ModifyGraph/Z marker[7]=28,marker[8]=3
	ModifyGraph/Z rgb[1]=(0,0,65535),rgb[2]=(2,39321,1),rgb[3]=(65535,43690,0),rgb[4]=(52428,1,41942)
	ModifyGraph/Z rgb[5]=(65535,32768,32768),rgb[6]=(32768,40777,65535),rgb[7]=(16386,65535,16385)
	ModifyGraph/Z rgb[8]=(52428,52425,1)
	ModifyGraph/Z msize=2.5
	ModifyGraph/Z grid(left)=1,grid(bottom)=1
	ModifyGraph/Z minor(left)=1,minor(bottom)=1
	ModifyGraph sep(left)=15,sep(bottom)=15
	ModifyGraph/Z gridStyle(left)=3
	// SetAxis/Z bottom plotBegin,plotEnd
EndMacro


Function AutoCarl(ctrlName) : ButtonControl
	String ctrlName
	String carlQuotes = "Run more tests;Check the ammeter;Nine months, tops!;Ask Andrew;Change the bearings"
	carlQuotes += ";Hey guys, watch this!;Narf!;It seized again;Use the precision adjusting tool;Let me do some calculations"
	carlQuotes += ";We need to clean up around here;That would affect the mixture ratio;Recycle some fittings;Let's go to the food trucks"
	carlQuotes += ";Aaarrghh!! Fucking Engine...;This engine's simpler;Run more tests;Call me Wotan - Wotan Caesar"
	carlQuotes += ";Let's pour the LN2 down the toilet;No! Don't do that!;We'll reimburse you for that;It machines just like brass"
	carlQuotes += ";Everything goes!;Looks like a piece of giant condor shit;Who wants to sign up for this?"
	carlQuotes += ";Let's assign it to Sam;Sam can take care of it;Ahhh...Magic!"

	String currentQuote
	Variable i, numInList
	numInList = ItemsInList(carlQuotes)
	i=(enoise(numInList)+numInList)/2
	print i
	currentQuote = StringFromList(i,carlQuotes,";")
	if (!WaveExists(Carl1))
		ImageLoad/T=jpeg/N=Carl1/G/P=Igor_Scripts/Q "Carl_photo.jpg"
		DoWindow/K Graph0
	endif
	DoWindow/K Auto_Carl_says
	PauseUpdate; Silent 1		// building window...
	Display /K=1/W=(40,40,309,318)
	DoWindow/C  Auto_Carl_says
	AppendImage/T Carl1
	ModifyImage Carl1 ctab= {*,*,Grays,0}
	ModifyGraph margin(left)=14,margin(bottom)=14,margin(top)=14,margin(right)=14
	ModifyGraph mirror=2
	ModifyGraph nticks=6
	ModifyGraph minor=1
	ModifyGraph fSize=9
	ModifyGraph standoff=0
	ModifyGraph tkLblRot(left)=90
	ModifyGraph btLen=3
	ModifyGraph tlOffset=-2
	SetAxis/A/R left
	SetDrawLayer UserFront
	DrawPoly 0.4688,0.436,1,1,{0.4688,0.436,0.2780,0.456,0.12448,0.512,0.04979,0.612,0.04564,0.756,0.13278,0.868,0.3775,0.72,0.19502,0.708,0.1452,0.636,0.17427,0.552,0.36514,0.476,0.46058,0.44}
	DrawOval 0.10788,0.716,0.94605,0.952
	SetDrawEnv fname= "Arial",textxjust= 1,fsize= 9
	DrawText 0.5311,0.8,"Auto-Carl says:"
	SetDrawEnv save
	SetDrawEnv textxjust= 1,fsize= 10
	DrawText 0.5228,0.87,currentQuote
//	Button closeBtn,pos={100,1},size={45,20},proc=closeWindow,title="Close"

End

